import sys

import lambda_main
from luna_lambda_tools.private.agent_unit_config import ServiceSettings


def updateAgentModules():
    """Update/patch modules for lambda-agent/luna-smith compatibility"""
    sys.modules["configs.config"] = lambda_main
    setattr(sys.modules["configs.config"], "SettingsCls", ServiceSettings)
    sys.modules["app.version"] = lambda_main
    setattr(sys.modules["app.version"], "VERSION", {"Version": {"api": 1, "major": 1, "minor": 0, "patch": 0}})

    for variable, value in (
        ("DEFAULT_PORT", 8000),
        ("REGISTRATION_ATTEMPT_COUNT", 5),
        ("REGISTRATION_ATTEMPT_DELAY", 1),
        ("ACCOUNT_ID", "00000000-0000-4000-b000-000000000146"),
        ("FEEDBACK_MAX_BATCH_COUNT", 1000),
        ("DUPLICATE_FEEDBACK_IGNORE_PERIOD", 5),
        ("WSCODE_GOING_AWAY", 1001),
        ("AGENT_NAME", "luna-lambda-video-agent"),
        ("AGENT_DESCRIPTION", "luna-lambda-video-agent"),
        ("ESTIMATORS_TARGETS", []),
        ("ESTIMATORS_TO_INITIALIZE", []),
    ):
        if hasattr(sys.modules["configs.config"], variable):
            continue
        setattr(sys.modules["configs.config"], variable, value)
