from typing import final

from .agent_unit_config import ServiceSettings as SettingsCls
from .base_application import BaseAppCtx, BaseLambdaApp, Luna3Session


class AppCtx[TConfig: ServiceSettings](BaseAppCtx):
    """Configurator application context"""

    #: lambda type
    lambdaType: str = "agent"
    luna3Session: Luna3Session | None

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.luna3session = Luna3Session(settings=self.serviceConfig, lambdaType=self.lambdaType)

    @final
    async def initialize(self):
        """Description see :func:`~_LunaApplication.initialize`"""
        await super().initialize()

    @final
    async def shutdown(self):
        await super().shutdown()


class AgentLambdaApp(BaseLambdaApp):
    """Agent lambda app"""

    # service context
    ctxCls = AppCtx
    # service config
    configCls = SettingsCls
