"""
Configs migration

Generation datetime: 2025-04-25 07:43:09.816175+00:00
"""

from configs_core.migration.db_migrate_helper import (
    DatabaseMigrationHelper,
    ExternalLimitationToModify,
    LimitationToModify,
)

mh: DatabaseMigrationHelper

REVISION = "3d7b4e91"
DOWN_REVISION = "5a084756"


limitationsToModify: list[LimitationToModify] = [
    LimitationToModify(
        limitationName="ADDITIONAL_SERVICES_USAGE",
        settingUpgradeFunction=lambda oldValue: oldValue,
        settingDowngradeFunction=lambda oldValue: oldValue,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=[
            "luna-admin",
            "luna-api",
            "luna-handlers",
            "luna-lambda",
            "luna-lambda-tasks-unit",
            "luna-lambda-unit",
            "luna-matcher-proxy",
            "luna-python-matcher",
            "luna-remote-sdk",
            "luna-tasks",
            "luna-video-agent",
            "luna-video-manager",
        ],
        newServices=[
            "luna-admin",
            "luna-api",
            "luna-handlers",
            "luna-lambda",
            "luna-lambda-agent-unit",
            "luna-lambda-tasks-unit",
            "luna-lambda-unit",
            "luna-matcher-proxy",
            "luna-python-matcher",
            "luna-remote-sdk",
            "luna-tasks",
            "luna-video-agent",
            "luna-video-manager",
        ],
    ),
    LimitationToModify(
        limitationName="LUNA_SENDER_ADDRESS",
        settingUpgradeFunction=lambda oldValue: oldValue,
        settingDowngradeFunction=lambda oldValue: oldValue,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=[
            "luna-admin",
            "luna-api",
            "luna-lambda-tasks-unit",
            "luna-lambda-unit",
            "luna-video-agent",
        ],
        newServices=[
            "luna-admin",
            "luna-api",
            "luna-lambda-agent-unit",
            "luna-lambda-tasks-unit",
            "luna-lambda-unit",
            "luna-video-agent",
        ],
    ),
    LimitationToModify(
        limitationName="LUNA_SENDER_TIMEOUTS",
        settingUpgradeFunction=lambda oldValue: oldValue,
        settingDowngradeFunction=lambda oldValue: oldValue,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=["luna-api", "luna-video-agent"],
        newServices=["luna-api", "luna-lambda-agent-unit", "luna-video-agent"],
    ),
    LimitationToModify(
        limitationName="LUNA_MONITORING",
        settingUpgradeFunction=lambda oldValue: oldValue,
        settingDowngradeFunction=lambda oldValue: oldValue,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=[
            "luna-accounts",
            "luna-admin",
            "luna-api",
            "luna-backport3",
            "luna-backport4",
            "luna-events",
            "luna-faces",
            "luna-handlers",
            "luna-image-store",
            "luna-lambda",
            "luna-lambda-tasks-unit",
            "luna-lambda-unit",
            "luna-licenses",
            "luna-matcher-proxy",
            "luna-python-matcher",
            "luna-remote-sdk",
            "luna-sender",
            "luna-streams-retranslator",
            "luna-tasks",
            "luna-video-agent",
            "luna-video-manager",
        ],
        newServices=[
            "luna-accounts",
            "luna-admin",
            "luna-api",
            "luna-backport3",
            "luna-backport4",
            "luna-events",
            "luna-faces",
            "luna-handlers",
            "luna-image-store",
            "luna-lambda",
            "luna-lambda-agent-unit",
            "luna-lambda-tasks-unit",
            "luna-lambda-unit",
            "luna-licenses",
            "luna-matcher-proxy",
            "luna-python-matcher",
            "luna-remote-sdk",
            "luna-sender",
            "luna-streams-retranslator",
            "luna-tasks",
            "luna-video-agent",
            "luna-video-manager",
        ],
    ),
    LimitationToModify(
        limitationName="LUNA_EVENTS_ADDRESS",
        settingUpgradeFunction=lambda oldValue: oldValue,
        settingDowngradeFunction=lambda oldValue: oldValue,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=[
            "luna-admin",
            "luna-api",
            "luna-handlers",
            "luna-lambda-tasks-unit",
            "luna-lambda-unit",
            "luna-tasks",
            "luna-video-agent",
        ],
        newServices=[
            "luna-admin",
            "luna-api",
            "luna-handlers",
            "luna-lambda-agent-unit",
            "luna-lambda-tasks-unit",
            "luna-lambda-unit",
            "luna-tasks",
            "luna-video-agent",
        ],
    ),
    LimitationToModify(
        limitationName="EXTERNAL_LUNA_API_ADDRESS",
        settingUpgradeFunction=lambda oldValue: oldValue,
        settingDowngradeFunction=lambda oldValue: oldValue,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=[
            "luna-api",
            "luna-handlers",
            "luna-lambda-tasks-unit",
            "luna-remote-sdk",
            "luna-tasks",
            "luna-video-agent",
        ],
        newServices=[
            "luna-api",
            "luna-handlers",
            "luna-lambda-agent-unit",
            "luna-lambda-tasks-unit",
            "luna-remote-sdk",
            "luna-tasks",
            "luna-video-agent",
        ],
    ),
    LimitationToModify(
        limitationName="LUNA_IMAGE_STORE_OBJECTS_ADDRESS",
        settingUpgradeFunction=lambda oldValue: oldValue,
        settingDowngradeFunction=lambda oldValue: oldValue,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=[
            "luna-api",
            "luna-lambda-tasks-unit",
            "luna-remote-sdk",
            "luna-tasks",
            "luna-video-agent",
        ],
        newServices=[
            "luna-api",
            "luna-lambda-agent-unit",
            "luna-lambda-tasks-unit",
            "luna-remote-sdk",
            "luna-tasks",
            "luna-video-agent",
        ],
    ),
    LimitationToModify(
        limitationName="LUNA_VIDEO_MANAGER_ADDRESS",
        settingUpgradeFunction=lambda oldValue: oldValue,
        settingDowngradeFunction=lambda oldValue: oldValue,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=["luna-admin", "luna-api", "luna-video-agent"],
        newServices=[
            "luna-admin",
            "luna-api",
            "luna-lambda-agent-unit",
            "luna-video-agent",
        ],
    ),
    LimitationToModify(
        limitationName="LUNA_IMAGE_STORE_OBJECTS_TIMEOUTS",
        settingUpgradeFunction=lambda oldValue: oldValue,
        settingDowngradeFunction=lambda oldValue: oldValue,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=["luna-api", "luna-video-agent"],
        newServices=["luna-api", "luna-lambda-agent-unit", "luna-video-agent"],
    ),
    LimitationToModify(
        limitationName="LUNA_VIDEO_MANAGER_TIMEOUTS",
        settingUpgradeFunction=lambda oldValue: oldValue,
        settingDowngradeFunction=lambda oldValue: oldValue,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=["luna-api", "luna-video-agent"],
        newServices=["luna-api", "luna-lambda-agent-unit", "luna-video-agent"],
    ),
    LimitationToModify(
        limitationName="LUNA_SERVICE_METRICS",
        settingUpgradeFunction=lambda oldValue: oldValue,
        settingDowngradeFunction=lambda oldValue: oldValue,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=[
            "luna-accounts",
            "luna-admin",
            "luna-api",
            "luna-backport3",
            "luna-backport4",
            "luna-events",
            "luna-faces",
            "luna-handlers",
            "luna-image-store",
            "luna-lambda",
            "luna-lambda-tasks-unit",
            "luna-lambda-unit",
            "luna-licenses",
            "luna-matcher-proxy",
            "luna-python-matcher",
            "luna-remote-sdk",
            "luna-sender",
            "luna-streams-retranslator",
            "luna-tasks",
            "luna-video-agent",
            "luna-video-manager",
        ],
        newServices=[
            "luna-accounts",
            "luna-admin",
            "luna-api",
            "luna-backport3",
            "luna-backport4",
            "luna-events",
            "luna-faces",
            "luna-handlers",
            "luna-image-store",
            "luna-lambda",
            "luna-lambda-agent-unit",
            "luna-lambda-tasks-unit",
            "luna-lambda-unit",
            "luna-licenses",
            "luna-matcher-proxy",
            "luna-python-matcher",
            "luna-remote-sdk",
            "luna-sender",
            "luna-streams-retranslator",
            "luna-tasks",
            "luna-video-agent",
            "luna-video-manager",
        ],
    ),
    LimitationToModify(
        limitationName="LUNA_EVENTS_TIMEOUTS",
        settingUpgradeFunction=lambda oldValue: oldValue,
        settingDowngradeFunction=lambda oldValue: oldValue,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=[
            "luna-api",
            "luna-handlers",
            "luna-lambda-tasks-unit",
            "luna-lambda-unit",
            "luna-tasks",
            "luna-video-agent",
        ],
        newServices=[
            "luna-api",
            "luna-handlers",
            "luna-lambda-agent-unit",
            "luna-lambda-tasks-unit",
            "luna-lambda-unit",
            "luna-tasks",
            "luna-video-agent",
        ],
    ),
    LimitationToModify(
        limitationName="LUNA_IMAGE_STORE_IMAGES_ADDRESS",
        settingUpgradeFunction=lambda oldValue: oldValue,
        settingDowngradeFunction=lambda oldValue: oldValue,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=[
            "luna-admin",
            "luna-api",
            "luna-handlers",
            "luna-lambda-tasks-unit",
            "luna-lambda-unit",
            "luna-remote-sdk",
            "luna-tasks",
            "luna-video-agent",
        ],
        newServices=[
            "luna-admin",
            "luna-api",
            "luna-handlers",
            "luna-lambda-agent-unit",
            "luna-lambda-tasks-unit",
            "luna-lambda-unit",
            "luna-remote-sdk",
            "luna-tasks",
            "luna-video-agent",
        ],
    ),
    LimitationToModify(
        limitationName="LUNA_IMAGE_STORE_IMAGES_TIMEOUTS",
        settingUpgradeFunction=lambda oldValue: oldValue,
        settingDowngradeFunction=lambda oldValue: oldValue,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=[
            "luna-api",
            "luna-handlers",
            "luna-lambda-tasks-unit",
            "luna-lambda-unit",
            "luna-remote-sdk",
            "luna-tasks",
            "luna-video-agent",
        ],
        newServices=[
            "luna-api",
            "luna-handlers",
            "luna-lambda-agent-unit",
            "luna-lambda-tasks-unit",
            "luna-lambda-unit",
            "luna-remote-sdk",
            "luna-tasks",
            "luna-video-agent",
        ],
    ),
    LimitationToModify(
        limitationName="LUNA_LICENSES_ADDRESS",
        settingUpgradeFunction=lambda oldValue: oldValue,
        settingDowngradeFunction=lambda oldValue: oldValue,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=[
            "luna-admin",
            "luna-api",
            "luna-faces",
            "luna-lambda",
            "luna-remote-sdk",
            "luna-video-agent",
            "luna-video-manager",
        ],
        newServices=[
            "luna-admin",
            "luna-api",
            "luna-faces",
            "luna-lambda",
            "luna-lambda-agent-unit",
            "luna-remote-sdk",
            "luna-video-agent",
            "luna-video-manager",
        ],
    ),
]

externalLimitationsToModify: list[ExternalLimitationToModify] = []


def upgrade():
    """Upgrade configs to new revision"""

    # limitations to add
    mh.addLimitation(
        limitationName="LUNA_LAMBDA_AGENT_UNIT_ACTIVE_PLUGINS",
        validationSchema={"type": "array", "items": {"type": "string"}},
        defaultValue=[],
        description="list of luna-lambda-agent-unit active plugins",
        services=["luna-lambda-agent-unit"],
        groupNames=["luna-platform"],
    )
    mh.addLimitation(
        limitationName="LUNA_LAMBDA_AGENT_UNIT_ANALYTICS_SETTINGS",
        validationSchema={
            "type": "object",
            "additionalProperties": True,
            "description": "lambda agent unit analytics settings",
        },
        defaultValue={},
        description="luna lambda agent analytics settings",
        services=["luna-lambda-agent-unit"],
        groupNames=["luna-platform"],
    )
    mh.addLimitation(
        limitationName="LUNA_LAMBDA_AGENT_UNIT_HTTP_SETTINGS",
        validationSchema={
            "type": "object",
            "properties": {
                "request_timeout": {"type": "integer", "minimum": 1},
                "response_timeout": {"type": "integer", "minimum": 1},
                "request_max_size": {"type": "integer", "minimum": 1},
                "keep_alive_timeout": {"type": "integer", "minimum": 1},
            },
            "additionalProperties": False,
        },
        defaultValue={
            "request_timeout": 60,
            "response_timeout": 600,
            "request_max_size": 1073741824,
            "keep_alive_timeout": 200,
        },
        description="Luna Lambda Agent Unit http settings",
        services=["luna-lambda-agent-unit"],
        groupNames=["luna-platform"],
    )
    mh.addLimitation(
        limitationName="LUNA_LAMBDA_AGENT_UNIT_LOGGER",
        validationSchema={
            "type": "object",
            "properties": {
                "log_level": {
                    "type": "string",
                    "enum": ["ERROR", "WARNING", "INFO", "DEBUG"],
                },
                "folder_with_logs": {"type": "string"},
                "max_log_file_size": {"type": "integer"},
                "log_time": {"type": "string", "enum": ["LOCAL", "UTC"]},
                "log_to_stdout": {"type": "boolean"},
                "log_to_file": {"type": "boolean"},
                "multiline_stack_trace": {"type": "boolean"},
                "format": {"type": "string", "enum": ["default", "json", "ecs"]},
            },
            "additionalProperties": False,
        },
        defaultValue={
            "log_level": "INFO",
            "folder_with_logs": "./",
            "max_log_file_size": 1024,
            "log_time": "LOCAL",
            "log_to_stdout": True,
            "log_to_file": False,
            "multiline_stack_trace": True,
            "format": "default",
        },
        description="Luna Lambda Agent Unit logger settings",
        services=["luna-lambda-agent-unit"],
        groupNames=["luna-platform"],
    )
    mh.addLimitation(
        limitationName="LUNA_LAMBDA_AGENT_UNIT_RUNTIME_SETTINGS",
        validationSchema={
            "type": "object",
            "properties": {
                "global_device_class": {"type": "string", "enum": ["cpu", "gpu"]},
                "num_threads": {"type": "integer", "minimum": 1},
                "num_compute_streams": {"type": "integer", "minimum": 1},
            },
            "description": "sdk runtime settings",
            "additionalProperties": False,
        },
        defaultValue={
            "global_device_class": "cpu",
            "num_threads": 6,
            "num_compute_streams": 4,
        },
        description="runtime settings for luna-lambda-agent-unit",
        services=["luna-lambda-agent-unit"],
        groupNames=["luna-platform", "luna-handlers-estimators-settings"],
    )
    mh.addLimitation(
        limitationName="LUNA_LAMBDA_AGENT_UNIT_SETTINGS",
        validationSchema={
            "type": "object",
            "properties": {"max_active_streams": {"type": "integer", "minimum": 1}},
            "description": "extended lambda agent unit settings",
            "additionalProperties": False,
        },
        defaultValue={"max_active_streams": 2},
        description="settings for luna-lambda-agent-unit",
        services=["luna-lambda-agent-unit"],
        groupNames=["luna-platform"],
    )
    mh.addLimitation(
        limitationName="LUNA_LAMBDA_AGENT_UNIT_VIDEO_SETTINGS",
        validationSchema={
            "type": "object",
            "properties": {
                "decoder_device_class": {
                    "type": "string",
                    "enum": ["cpu", "gpu", "auto"],
                },
                "decoder_worker_count": {"type": "integer", "minimum": 1},
                "max_size": {"type": "integer", "minimum": 1},
                "timeouts": {
                    "type": "object",
                    "properties": {
                        "request": {"type": "number", "exclusiveMinimum": 0},
                        "connect": {"type": "number", "exclusiveMinimum": 0},
                        "sock_connect": {"type": "number", "exclusiveMinimum": 0},
                        "sock_read": {"type": "number", "exclusiveMinimum": 0},
                    },
                    "description": "timeouts in seconds",
                    "additionalProperties": False,
                },
                "frame_pool_size": {"type": "integer", "minimum": 1},
                "ffmpeg_thread_count": {"type": "integer", "minimum": 0},
            },
            "description": "video processing settings",
            "additionalProperties": False,
        },
        defaultValue={
            "decoder_device_class": "auto",
            "decoder_worker_count": 10,
            "frame_pool_size": 10,
            "ffmpeg_thread_count": 0,
            "max_size": 2048,
            "timeouts": {
                "connect": 30.0,
                "request": 60.0,
                "sock_connect": 10.0,
                "sock_read": 60.0,
            },
        },
        description="luna-lambda-agent-unit video processing settings",
        services=["luna-lambda-agent-unit"],
        groupNames=["luna-platform"],
    )

    # limitations to modify
    for limitation in limitationsToModify:
        mh.migrateLimitation(limitation)


def downgrade():
    """Downgrade configs to previous revision"""

    # limitations to modify
    for limitation in limitationsToModify:
        mh.migrateLimitation(limitation)

    # limitations to remove
    mh.removeLimitation(limitationName="LUNA_LAMBDA_AGENT_UNIT_ACTIVE_PLUGINS")
    mh.removeLimitation(limitationName="LUNA_LAMBDA_AGENT_UNIT_ANALYTICS_SETTINGS")
    mh.removeLimitation(limitationName="LUNA_LAMBDA_AGENT_UNIT_HTTP_SETTINGS")
    mh.removeLimitation(limitationName="LUNA_LAMBDA_AGENT_UNIT_LOGGER")
    mh.removeLimitation(limitationName="LUNA_LAMBDA_AGENT_UNIT_RUNTIME_SETTINGS")
    mh.removeLimitation(limitationName="LUNA_LAMBDA_AGENT_UNIT_SETTINGS")
    mh.removeLimitation(limitationName="LUNA_LAMBDA_AGENT_UNIT_VIDEO_SETTINGS")
